## mingw-w64-alembic-1.8.5-3.src.tar.zst

=== lib/Alembic/AbcCoreAbstract/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcCoreAbstract/Foundation.cpp
    AbcCoreAbstract/TimeSampling.cpp
    AbcCoreAbstract/TimeSamplingType.cpp
    AbcCoreAbstract/ArraySample.cpp
    AbcCoreAbstract/ReadArraySampleCache.cpp
    AbcCoreAbstract/ScalarSample.cpp
    AbcCoreAbstract/BasePropertyWriter.cpp
    AbcCoreAbstract/ScalarPropertyWriter.cpp
    AbcCoreAbstract/ArrayPropertyWriter.cpp
    AbcCoreAbstract/CompoundPropertyWriter.cpp
    AbcCoreAbstract/ObjectWriter.cpp
    AbcCoreAbstract/ArchiveWriter.cpp
    AbcCoreAbstract/BasePropertyReader.cpp
    AbcCoreAbstract/ScalarPropertyReader.cpp
    AbcCoreAbstract/ArrayPropertyReader.cpp
    AbcCoreAbstract/CompoundPropertyReader.cpp
    AbcCoreAbstract/ObjectReader.cpp
    AbcCoreAbstract/ArchiveReader.cpp
)

SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES
    All.h
    ForwardDeclarations.h
    ArraySample.h
    ArraySampleKey.h
    ReadArraySampleCache.h
    ScalarSample.h
    DataType.h
    Foundation.h
    MetaData.h
    ObjectHeader.h
    PropertyHeader.h
    TimeSampling.h
    TimeSamplingType.h
    BasePropertyWriter.h
    ScalarPropertyWriter.h
    ArrayPropertyWriter.h
    CompoundPropertyWriter.h
    ObjectWriter.h
    ArchiveWriter.h
    BasePropertyReader.h
    ScalarPropertyReader.h
    ArrayPropertyReader.h
    CompoundPropertyReader.h
    ObjectReader.h
    ArchiveReader.h
    DESTINATION include/Alembic/AbcCoreAbstract
)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== lib/Alembic/AbcCoreFactory/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2013-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcCoreFactory/IFactory.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES All.h IFactory.h
        DESTINATION include/Alembic/AbcCoreFactory)

=== lib/Alembic/AbcCoreHDF5/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcCoreHDF5/AprImpl.cpp
    AbcCoreHDF5/ApwImpl.cpp
    AbcCoreHDF5/ArImpl.cpp
    AbcCoreHDF5/AwImpl.cpp
    AbcCoreHDF5/CacheImpl.cpp
    AbcCoreHDF5/CprData.cpp
    AbcCoreHDF5/CprImpl.cpp
    AbcCoreHDF5/CpwData.cpp
    AbcCoreHDF5/CpwImpl.cpp
    AbcCoreHDF5/DataTypeRegistry.cpp
    AbcCoreHDF5/HDF5Hierarchy.cpp
    AbcCoreHDF5/HDF5HierarchyReader.cpp
    AbcCoreHDF5/HDF5HierarchyWriter.cpp
    AbcCoreHDF5/HDF5Util.cpp
    AbcCoreHDF5/OrData.cpp
    AbcCoreHDF5/OrImpl.cpp
    AbcCoreHDF5/OwData.cpp
    AbcCoreHDF5/OwImpl.cpp
    AbcCoreHDF5/ReadUtil.cpp
    AbcCoreHDF5/ReadWrite.cpp
    AbcCoreHDF5/SprImpl.cpp
    AbcCoreHDF5/SpwImpl.cpp
    AbcCoreHDF5/StringReadUtil.cpp
    AbcCoreHDF5/StringWriteUtil.cpp
    AbcCoreHDF5/WriteUtil.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES All.h ReadWrite.h
        DESTINATION include/Alembic/AbcCoreHDF5)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== lib/Alembic/AbcCoreLayer/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2016,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcCoreLayer/ArImpl.cpp
    AbcCoreLayer/CprImpl.cpp
    AbcCoreLayer/OrImpl.cpp
    AbcCoreLayer/Read.cpp
    AbcCoreLayer/Util.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES Read.h Util.h Foundation.h
        DESTINATION include/Alembic/AbcCoreLayer)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== lib/Alembic/AbcGeom/CMakeLists.txt ===
##-*****************************************************************************
##
## Copyright (c) 2009-2015,
##  Sony Pictures Imageworks Inc. and
##  Industrial Light & Magic, a division of Lucasfilm Entertainment Company Ltd.
##
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions are
## met:
## *       Redistributions of source code must retain the above copyright
## notice, this list of conditions and the following disclaimer.
## *       Redistributions in binary form must reproduce the above
## copyright notice, this list of conditions and the following disclaimer
## in the documentation and/or other materials provided with the
## distribution.
## *       Neither the name of Industrial Light & Magic nor the names of
## its contributors may be used to endorse or promote products derived
## from this software without specific prior written permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##
##-*****************************************************************************

LIST(APPEND CXX_FILES
    AbcGeom/ArchiveBounds.cpp
    AbcGeom/GeometryScope.cpp
    AbcGeom/FilmBackXformOp.cpp
    AbcGeom/CameraSample.cpp
    AbcGeom/ICamera.cpp
    AbcGeom/OCamera.cpp
    AbcGeom/Basis.cpp
    AbcGeom/ICurves.cpp
    AbcGeom/OCurves.cpp
    AbcGeom/OFaceSet.cpp
    AbcGeom/IFaceSet.cpp
    AbcGeom/OLight.cpp
    AbcGeom/ILight.cpp
    AbcGeom/ONuPatch.cpp
    AbcGeom/INuPatch.cpp
    AbcGeom/OPoints.cpp
    AbcGeom/IPoints.cpp
    AbcGeom/OPolyMesh.cpp
    AbcGeom/IPolyMesh.cpp
    AbcGeom/OSubD.cpp
    AbcGeom/ISubD.cpp
    AbcGeom/Visibility.cpp
    AbcGeom/XformOp.cpp
    AbcGeom/XformSample.cpp
    AbcGeom/IXform.cpp
    AbcGeom/OXform.cpp
)
SET(CXX_FILES "${CXX_FILES}" PARENT_SCOPE)

INSTALL(FILES
    All.h
    Foundation.h
    ArchiveBounds.h
    IGeomBase.h
    OGeomBase.h
    GeometryScope.h
    SchemaInfoDeclarations.h
    OLight.h
    ILight.h
    FilmBackXformOp.h
    CameraSample.h
    ICamera.h
    OCamera.h
    Basis.h
    CurveType.h
    ICurves.h
    OCurves.h
    FaceSetExclusivity.h
    OFaceSet.h
    IFaceSet.h
    ONuPatch.h
    INuPatch.h
    OGeomParam.h
    IGeomParam.h
    OPoints.h
    IPoints.h
    OPolyMesh.h
    IPolyMesh.h
    OSubD.h
    ISubD.h
    Visibility.h
    XformOp.h
    XformSample.h
    IXform.h
    OXform.h
    DESTINATION include/Alembic/AbcGeom
)

IF (USE_TESTS)
    ADD_SUBDIRECTORY(Tests)
ENDIF()

=== PKGBUILD ===
# Maintainer: Andrew Sun <adsun701@gmail.com>

_realname=alembic
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.8.5
pkgrel=3
pkgdesc="A open framework for storing and sharing scene data (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.alembic.io/"
msys2_repository_url="https://github.com/alembic/alembic"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-imath"
         "${MINGW_PACKAGE_PREFIX}-hdf5")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
             #"${MINGW_PACKAGE_PREFIX}-boost"
             #"${MINGW_PACKAGE_PREFIX}-python")
#optdepends=("${MINGW_PACKAGE_PREFIX}-boost: Python bindings"
#            "${MINGW_PACKAGE_PREFIX}-python: Python bindings")
source=("https://github.com/alembic/${_realname}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-alembic-1.7.9-fix-windows-build.patch"
        "0002-alembic-1.7.9-remove-msc_ver-and-fix-builtins-and-includes.patch")
sha256sums=('180a12f08d391cd89f021f279dbe3b5423b1db751a9898540c8059a45825c2e9'
            '81df673984894ec38b8a24aeb8d3f17a02b3aa697c2c943970b8984024ab9a64'
            '639eec0611f3f40a74003e58946f556e6e4e0a54c85f10bcda8c3da1b1de6a81')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  patch -Np1 -i "${srcdir}/0001-alembic-1.7.9-fix-windows-build.patch"
  patch -Np1 -i "${srcdir}/0002-alembic-1.7.9-remove-msc_ver-and-fix-builtins-and-includes.patch"
}

build() {
  # Static Build
  mkdir -p "${srcdir}"/build-${MSYSTEM}-static && cd "${srcdir}"/build-${MSYSTEM}-static

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  export OPENEXR_ROOT=${MINGW_PREFIX}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DUSE_HDF5=ON \
      -DUSE_STATIC_HDF5=ON \
      -DUSE_BINARIES=OFF \
      -DUSE_TESTS=OFF \
      -DALEMBIC_ILMBASE_LINK_STATIC=OFF \
      -DALEMBIC_SHARED_LIBS=OFF \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .

  # Shared Build
  mkdir -p "${srcdir}"/build-${MSYSTEM}-shared && cd "${srcdir}"/build-${MSYSTEM}-shared

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DUSE_HDF5=ON \
      -DUSE_PYALEMBIC=OFF \
      -DUSE_TESTS=OFF \
      -DALEMBIC_SHARED_LIBS=ON \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  # Static Install
  cd "${srcdir}"/build-${MSYSTEM}-static
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  # Shared Install
  cd "${srcdir}"/build-${MSYSTEM}-shared
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  local WINPREFIX=$(cygpath -wm ${MINGW_PREFIX})
  # Fix paths
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake" -type f -name '*.cmake' \
    -exec sed -i -e "s|${WINPREFIX}|\$\{_IMPORT_PREFIX\}|g" {} \;

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
